/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.18 Revision 1.97
1# Copyright 2007-2008 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.18 2008/11/22 01:23:31 jmbsvicetto Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.97 2011/06/07 20:11:04 abcd Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 monolithic ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: This eclass uses the SLOT dependencies from EAPI="1" or compatible, 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# and use deps from EAPI="2", hence you must define EAPI="2" in the ebuild, 14# over time as new EAPI versions are approved.
15# before inheriting any eclasses.
16 15
17inherit base cmake-utils eutils kde4-functions multilib 16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION:
18# For proper description see virtualx.eclass manpage.
19# Here we redefine default value to be manual, if your package needs virtualx
20# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
21: ${VIRTUALX_REQUIRED:=manual}
18 22
19case "${EAPI}" in 23inherit kde4-functions toolchain-funcs fdo-mime gnome2-utils base virtualx versionator eutils
20 2)
21 EXPORT_FUNCTIONS pkg_setup src_unpack src_configure src_compile src_test src_install pkg_postinst pkg_postrm
22 ;;
23 *)
24 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_postinst pkg_postrm
25 ;;
26esac
27 24
28# Set the qt dependencies 25if [[ ${BUILD_TYPE} = live ]]; then
29kde4-base_set_qt_dependencies() { 26 case ${KDE_SCM} in
30 local qt qtcore qtgui qt3support qtdepend qtopengldepend 27 svn) inherit subversion ;;
31 28 git) inherit git-2 ;;
32 # use dependencies
33 case "${EAPI}" in
34 2 | 2_pre3 | 2_pre2 | 2_pre1)
35
36 qt="["
37 case "${OPENGL_REQUIRED}" in
38 always)
39 qt="${qt}opengl,"
40 ;;
41 optional)
42 qt="${qt}opengl?,"
43 ;;
44 esac
45 qt="${qt}accessibility,dbus,gif,jpeg,png,qt3support,ssl,zlib]"
46 qtcore="[qt3support,ssl]"
47 qtgui="[accessibility,dbus]"
48 qt3support="[accessibility]"
49 ;;
50 esac 29 esac
30fi
51 31
52 # split qt 32# @ECLASS-VARIABLE: CMAKE_REQUIRED
53 qtdepend=" 33# @DESCRIPTION:
54 x11-libs/qt-core:4${qtcore} 34# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
55 x11-libs/qt-gui:4${qtgui} 35# Please note that if it's set to 'never' you need to explicitly override following phases:
56 x11-libs/qt-qt3support:4${qt3support} 36# src_configure, src_compile, src_test and src_install.
57 x11-libs/qt-script:4 37# Defaults to 'always'.
58 x11-libs/qt-svg:4 38: ${CMAKE_REQUIRED:=always}
59 x11-libs/qt-test:4" 39if [[ ${CMAKE_REQUIRED} = always ]]; then
60 qtopengldepend="x11-libs/qt-opengl:4" 40 buildsystem_eclass="cmake-utils"
41 export_fns="src_configure src_compile src_test src_install"
42fi
61 43
62 # allow monolithic qt for PV < 4.1 44# @ECLASS-VARIABLE: KDE_MINIMAL
45# @DESCRIPTION:
46# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
47# version for apps to work. Currently defaults to 4.4
48# One may override this variable to raise version requirements.
49# Note that it is fixed to ${PV} for kde-base packages.
50KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
51
52# Set slot for KDEBASE known packages
53case ${KDEBASE} in
54 kde-base)
55 SLOT=$(get_kde_version)
56 [[ -z ${SLOT} ]] && die "Unsupported PV ${PV}"
57 KDE_MINIMAL="${PV}"
58 ;;
59 koffice)
60 SLOT="2"
61 ;;
62 kdevelop)
63 if [[ ${BUILD_TYPE} = live ]]; then
64 # @ECLASS-VARIABLE: KDEVELOP_VERSION
65 # @DESCRIPTION:
66 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
67 # Applies to KDEBASE=kdevelop only.
68 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
69 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
70 # @DESCRIPTION:
71 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
72 # Applies to KDEBASE=kdevelop only.
73 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
74 else
63 case "${PV}" in 75 case ${PN} in
64 scm|9999*|4.1*|4.0.9*|4.0.8*) : ;; 76 kdevelop|quanta)
77 KDEVELOP_VERSION=${PV}
78 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
79 ;;
80 kdevplatform)
81 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
82 KDEVPLATFORM_VERSION=${PV}
83 ;;
65 *) 84 *)
66 qtdepend="|| ( ( ${qtdepend} ) >=x11-libs/qt-4.3.3:4${qt} )" 85 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
67 qtopengldepend="|| ( ${qtopengldepend} >=x11-libs/qt-4.3.3:4 )" 86 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
87 esac
88 fi
89 SLOT="4"
68 ;; 90 ;;
69 esac 91esac
70 92
71 # opengl dependencies 93inherit ${buildsystem_eclass}
72 case "${OPENGL_REQUIRED}" in
73 always)
74 qtdepend="${qtdepend}
75 ${qtopengldepend}"
76 ;;
77 optional)
78 IUSE="${IUSE} opengl"
79 qtdepend="${qtdepend}
80 opengl? ( ${qtopengldepend} )"
81 ;;
82 *)
83 OPENGL_REQUIRED="never"
84 ;;
85 esac
86 94
87 COMMONDEPEND="${COMMONDEPEND} ${qtdepend} !x11-libs/qt-phonon" 95EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
88}
89kde4-base_set_qt_dependencies
90 96
91# Set the cmake dependencies 97unset buildsystem_eclass
92case "${PV}" in 98unset export_fns
93 9999*)
94 CMAKEDEPEND=">=dev-util/cmake-2.6"
95 ;;
96 *)
97 CMAKEDEPEND=">=dev-util/cmake-2.4.7-r1"
98 ;;
99esac
100 99
101# Set the common dependencies 100# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
102DEPEND="${DEPEND} ${COMMONDEPEND} ${CMAKEDEPEND} 101# @DESCRIPTION:
103 dev-util/pkgconfig 102# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
104 kde-base/automoc 103# This variable must be set before inheriting any eclasses. Defaults to 'never'.
105 x11-libs/libXt 104DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
106 x11-proto/xf86vidmodeproto"
107RDEPEND="${RDEPEND} ${COMMONDEPEND}"
108 105
109# Add the kdeprefix use flag 106# @ECLASS-VARIABLE: QTHELP_REQUIRED
110case "${EAPI}" in 107# @DESCRIPTION:
111 2 | 2_pre3 | 2_pre2 | 2_pre1) 108# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
112 IUSE="${IUSE} kdeprefix" 109# This variable must be set before inheriting any eclasses. Defaults to 'never'.
113 ;; 110QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
114esac
115 111
116# @ECLASS-VARIABLE: OPENGL_REQUIRED 112# @ECLASS-VARIABLE: OPENGL_REQUIRED
117# @DESCRIPTION: 113# @DESCRIPTION:
118# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 114# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
119# This variable must be set before inheriting any eclasses. Defaults to 'never'. 115# This variable must be set before inheriting any eclasses. Defaults to 'never'.
120OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 116OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
121 117
118# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
119# @DESCRIPTION:
120# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
121# This variable must be set before inheriting any eclasses. Defaults to 'never'.
122MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
123
122# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 124# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
123# @DESCRIPTION: 125# @DESCRIPTION:
124# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 126# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
125# This variable must be set before inheriting any eclasses. Defaults to 'never'. 127# This variable must be set before inheriting any eclasses. Defaults to 'never'.
126CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}" 128CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
127 129
128case "${CPPUNIT_REQUIRED}" in 130# @ECLASS-VARIABLE: KDE_REQUIRED
131# @DESCRIPTION:
132# Is kde required? Possible values are 'always', 'optional' and 'never'.
133# This variable must be set before inheriting any eclasses. Defaults to 'always'
134# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
135# Note that for kde-base packages this variable is fixed to 'always'.
136KDE_REQUIRED="${KDE_REQUIRED:-always}"
137
138# @ECLASS-VARIABLE: KDE_HANDBOOK
139# @DESCRIPTION:
140# Set to enable handbook in application. Possible values are 'always', 'optional'
141# (handbook USE flag) and 'never'.
142# This variable must be set before inheriting any eclasses. Defaults to 'never'.
143# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
144# ensures buildtime and runtime dependencies.
145KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
146
147# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
148# @DESCRIPTION:
149# Set this varible if you want your live package to manage its
150# translations. (Mostly all kde ebuilds does not ship documentation
151# and translations in live ebuilds)
152if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
153 # Kdebase actualy provides the handbooks even for live stuff
154 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
155 KDE_LINGUAS=""
156fi
157
158# Setup packages inheriting this eclass
159case ${KDEBASE} in
160 kde-base)
161 HOMEPAGE="http://www.kde.org/"
162 LICENSE="GPL-2"
163 if [[ $BUILD_TYPE = live ]]; then
164 # Disable tests for live ebuilds
165 RESTRICT+=" test"
166 fi
167
168 # Only add the kdeprefix USE flag for older versions, to help
169 # non-portage package managers handle the upgrade
170 if [[ ${PV} < 4.6.4 ]]; then
171 IUSE+=" kdeprefix"
172 fi
173
174 # This code is to prevent portage from searching GENTOO_MIRRORS for
175 # packages that will never be mirrored. (As they only will ever be in
176 # the overlay).
177 case ${PV} in
178 *9999* | 4.?.[6-9]?)
179 RESTRICT+=" mirror"
180 ;;
181 esac
182 # Block installation of other SLOTS unless kdeprefix
183 RDEPEND+=" $(block_other_slots)"
184 ;;
185 koffice)
186 HOMEPAGE="http://www.koffice.org/"
187 LICENSE="GPL-2"
188 ;;
189 kdevelop)
190 HOMEPAGE="http://www.kdevelop.org/"
191 LICENSE="GPL-2"
192 ;;
193esac
194
195# @ECLASS-VARIABLE: QT_MINIMAL
196# @DESCRIPTION:
197# Determine version of qt we enforce as minimal for the package.
198if version_is_at_least 4.5.50 "${KDE_MINIMAL}"; then
199 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
200else
201 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
202fi
203
204# Declarative dependencies
205qtdeclarativedepend="
206 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
207"
208case ${DECLARATIVE_REQUIRED} in
129 always) 209 always)
130 DEPEND="${DEPEND} dev-util/cppunit" 210 COMMONDEPEND+=" ${qtdeclarativedepend}"
131 ;; 211 ;;
132 optional) 212 optional)
133 IUSE="${IUSE} test" 213 IUSE+=" declarative"
134 DEPEND="${DEPEND} 214 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
135 test? ( dev-util/cppunit )"
136 ;; 215 ;;
137 *) 216 *) ;;
138 CPPUNIT_REQUIRED="never" 217esac
218unset qtdeclarativedepend
219
220# QtHelp dependencies
221qthelpdepend="
222 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
223"
224case ${QTHELP_REQUIRED} in
225 always)
226 COMMONDEPEND+=" ${qthelpdepend}"
139 ;; 227 ;;
228 optional)
229 IUSE+=" qthelp"
230 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
231 ;;
140esac 232esac
233unset qthelpdepend
141 234
142# @ECLASS-VARIABLE: NEED_KDE 235# OpenGL dependencies
236qtopengldepend="
237 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
238"
239case ${OPENGL_REQUIRED} in
240 always)
241 COMMONDEPEND+=" ${qtopengldepend}"
242 ;;
243 optional)
244 IUSE+=" opengl"
245 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
246 ;;
247 *) ;;
248esac
249unset qtopengldepend
250
251# MultiMedia dependencies
252qtmultimediadepend="
253 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
254"
255case ${MULTIMEDIA_REQUIRED} in
256 always)
257 COMMONDEPEND+=" ${qtmultimediadepend}"
258 ;;
259 optional)
260 IUSE+=" multimedia"
261 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
262 ;;
263 *) ;;
264esac
265unset qtmultimediadepend
266
267# CppUnit dependencies
268cppuintdepend="
269 dev-util/cppunit
270"
271case ${CPPUNIT_REQUIRED} in
272 always)
273 DEPEND+=" ${cppuintdepend}"
274 ;;
275 optional)
276 IUSE+=" test"
277 DEPEND+=" test? ( ${cppuintdepend} )"
278 ;;
279 *) ;;
280esac
281unset cppuintdepend
282
283
284# WebKit use dependencies
285case ${KDE_REQUIRED} in
286 always)
287 qtwebkitusedeps="[kde]"
288 ;;
289 optional)
290 qtwebkitusedeps="[kde?]"
291 ;;
292 *) ;;
293esac
294# KDE dependencies
295# Qt accessibility classes are needed in various places, bug 325461
296kdecommondepend="
297 dev-lang/perl
298 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
299 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
300 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
301 >=x11-libs/qt-script-${QT_MINIMAL}:4
302 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
303 >=x11-libs/qt-svg-${QT_MINIMAL}:4
304 >=x11-libs/qt-test-${QT_MINIMAL}:4
305 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
306 !aqua? (
307 x11-libs/libXext
308 x11-libs/libXt
309 x11-libs/libXxf86vm
310 x11-libs/libXcomposite
311 )
312"
313
314if [[ ${PN} != kdelibs ]]; then
315 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
316 if [[ ${KDEBASE} = kdevelop ]]; then
317 if [[ ${PN} != kdevplatform ]]; then
318 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
143# @DESCRIPTION: 319 # @DESCRIPTION:
144# This variable sets the version of KDE4 which will be used by the eclass. 320 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
145# This variable must be set by the ebuild, for all categories except for "kde-base". 321 # Applies to KDEBASE=kdevelop only.
146# For kde-base packages, if it is not set by the ebuild, 322 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
147# it's assumed that the required KDE4 version is the latest, non-live, available. 323 case ${KDEVPLATFORM_REQUIRED} in
148# 324 always)
149# @CODE 325 kdecommondepend+="
150# Acceptable values are: 326 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
151# - latest - Use latest version in the portage tree 327 "
152# Default for kde-base ebuilds. Banned for ebuilds not part of kde or koffice. 328 ;;
153# - svn - Use svn release (live ebuilds)
154# - :SLOT - Use any version in the SLOT specified in the NEED_KDE value.
155# - VERSION_NUMBER - Use the minimum KDE4 version specified in the NEED_KDE value.
156# - VERSION_NUMBER:SLOT - Use the minimum KDE4 version and the SLOT specified in the NEED_KDE value.
157# - none - Let the ebuild handle SLOT, kde dependencies, KDEDIR, ...
158# @CODE
159#
160# Note: There is no default NEED_KDE for ebuilds not in kde-base or part of
161# koffice, so you must set it explicitly in the ebuild, in all other cases.
162if [[ -z ${NEED_KDE} ]]; then
163 if [[ -n ${KDEBASE} ]]; then
164 NEED_KDE="latest"
165 else
166 die "kde4-base.eclass inherited but NEED_KDE not defined - broken ebuild"
167 fi
168fi
169export NEED_KDE
170
171case ${NEED_KDE} in
172 latest)
173 # Should only be used by 'kde-base'-ebuilds
174 if [[ "${KDEBASE}" == "kde-base" ]]; then
175 case ${PV} in
176 4.1*| 4.0.9* | 4.0.8*)
177 _kdedir="4.1"
178 _pv="-${PV}:4.1" ;;
179 4.0*)
180 _kdedir="4.0"
181 _pv="-${PV}:kde-4" ;;
182 3.9*)
183 _kdedir="3.9"
184 _pv="-${PV}:kde-4" ;;
185 *) 329 *) ;;
186 die "NEED_KDE=latest not supported for PV=${PV}" ;;
187 esac
188 _operator=">="
189 else
190 case ${PV} in
191 4.1 | 4.0.9* | 4.0.8*) _kdedir="4.1" ;;
192 4.0*) _kdedir="4.0" ;;
193 3.9*) _kdedir="3.9" ;;
194 *) die "NEED_KDE=latest not supported for PV=${PV}" ;;
195 esac 330 esac
196 fi 331 fi
197 ;; 332 fi
333fi
198 334
199 # NEED_KDE=":${SLOT}" 335kdedepend="
200 :kde-svn) 336 dev-util/automoc
201 _kdedir="svn" 337 dev-util/pkgconfig
202 _pv="-${NEED_KDE}" 338 !aqua? (
203 export NEED_KDE="svn" 339 >=x11-libs/libXtst-1.1.0
204 ;; 340 x11-proto/xf86vidmodeproto
205 :4.1)
206 _kdedir="4.1"
207 _pv="${NEED_KDE}"
208 ;;
209 :kde-4)
210 _kdedir="4.0"
211 _pv="${NEED_KDE}"
212 ;;
213
214 # NEED_KDE="${PV}:${SLOT}"
215 *:kde-svn)
216 _kdedir="svn"
217 _operator=">="
218 _pv="-${NEED_KDE}"
219 export NEED_KDE="svn"
220 ;;
221 *:4.1)
222 _kdedir="4.1"
223 _operator=">="
224 _pv="-${NEED_KDE}"
225 ;;
226 *:kde-4)
227 _kdedir="4.0"
228 _operator=">="
229 _pv="-${NEED_KDE}"
230 ;;
231
232 # NEED_KDE="${PV}"
233 scm|svn|9999*)
234 _kdedir="svn"
235 _operator=">="
236 _pv="-${NEED_KDE}:kde-svn"
237 export NEED_KDE="svn"
238 ;;
239 4.1 | 4.0.9* | 4.0.8*)
240 _kdedir="4.1"
241 _operator=">="
242 _pv="-${NEED_KDE}:4.1"
243 ;;
244 4.0* | 4)
245 _kdedir="4.0"
246 _operator=">="
247 _pv="-${NEED_KDE}:kde-4"
248 ;;
249 3.9*)
250 _kdedir="3.9"
251 _operator=">="
252 _pv="-${NEED_KDE}:kde-4"
253 ;;
254
255 # The ebuild handles dependencies, KDEDIR, SLOT.
256 none)
257 :
258 ;;
259
260 *) 341 )
261 die "NEED_KDE=${NEED_KDE} currently not supported." 342"
262 ;;
263esac
264 343
265if [[ ${NEED_KDE} != none ]]; then 344kderdepend=""
266 345
267 #Set the SLOT 346# all packages needs oxygen icons for basic iconset
347if [[ ${PN} != oxygen-icons ]]; then
348 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
349fi
350
351# add a dependency over kde-l10n if EAPI4 or better is around
352if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
353 for _lingua in ${KDE_LINGUAS}; do
354 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
355 # but only for selected ones.
356 # this can't be done on one line because if user doesn't use any localisation
357 # then he is probably not interested in kde-l10n at all.
358 kderdepend+="
359 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
360 "
361 done
362 unset _lingua
363fi
364
365kdehandbookdepend="
366 app-text/docbook-xml-dtd:4.2
367 app-text/docbook-xsl-stylesheets
368"
369kdehandbookrdepend="
370 $(add_kdebase_dep kdelibs 'handbook')
371"
372case ${KDE_HANDBOOK} in
373 always)
374 kdedepend+=" ${kdehandbookdepend}"
375 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
376 ;;
377 optional)
378 IUSE+=" +handbook"
379 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
380 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
381 ;;
382 *) ;;
383esac
384unset kdehandbookdepend kdehandbookrdepend
385
386case ${KDE_REQUIRED} in
387 always)
388 IUSE+=" aqua"
389 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
390 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
391 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
392 ;;
393 optional)
394 IUSE+=" aqua kde"
395 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
396 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
397 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
398 ;;
399 *) ;;
400esac
401
402unset kdecommondepend kdedepend kderdepend
403
404debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
405debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
406debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
407
408# Accumulate dependencies set by this eclass
409DEPEND+=" ${COMMONDEPEND}"
410RDEPEND+=" ${COMMONDEPEND}"
411unset COMMONDEPEND
412
413# Add experimental kdeenablefinal, masked by default
414IUSE+=" kdeenablefinal"
415
416# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
417# koffice ebuild, the URI should be set in the ebuild itself
418_calculate_src_uri() {
419 debug-print-function ${FUNCNAME} "$@"
420
421 local _kmname _kmname_pv
422
423 # we calculate URI only for known KDEBASE modules
424 [[ -n ${KDEBASE} ]] || return
425
426 # calculate tarball module name
268 if [[ -n ${KDEBASE} ]]; then 427 if [[ -n ${KMNAME} ]]; then
269 if [[ ${NEED_KDE} = svn ]]; then 428 # fixup kdebase-apps name
270 SLOT="kde-svn" 429 case ${KMNAME} in
430 kdebase-apps)
431 _kmname="kdebase" ;;
432 *)
433 _kmname="${KMNAME}" ;;
434 esac
271 else 435 else
436 _kmname=${PN}
437 fi
438 _kmname_pv="${_kmname}-${PV}"
439 case ${KDEBASE} in
440 kde-base)
272 case ${PV} in 441 case ${PV} in
273 4.1* | 4.0.9* | 4.0.8*) SLOT="4.1" ;; 442 4.[456].8[05] | 4.[456].9[023568])
274 *) SLOT="kde-4" ;; 443 # Unstable KDE SC releases
444 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2"
445 # KDEPIM IS SPECIAL
446 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname_pv}.tar.bz2"
447 ;;
448 4.4.[6789] | 4.4.1?*)
449 # Stable kdepim releases
450 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
451 ;;
452 *)
453 # Stable KDE SC releases
454 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2"
455 ;;
275 esac 456 esac
276 fi 457 ;;
277 fi 458 koffice)
278
279 # Block install of other SLOTS unless kdeprefix
280 case "${EAPI}" in 459 case ${PV} in
281 2 | 2_pre3 | 2_pre2 | 2_pre1) 460 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
282 for KDE_SLOT in ${KDE_SLOTS[@]}; do 461 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
283 # block non kdeprefix ${PN} on other slots 462 esac
284 if [[ ${SLOT} != ${KDE_SLOT} ]]; then 463 ;;
285 DEPEND="${DEPEND} 464 kdevelop)
286 !kdeprefix? ( !kde-base/${PN}:${KDE_SLOT}[-kdeprefix] )" 465 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
287 RDEPEND="${RDEPEND}
288 !kdeprefix? ( !kde-base/${PN}:${KDE_SLOT}[-kdeprefix] )"
289 fi
290 done
291 ;; 466 ;;
292 esac 467 esac
468}
293 469
294 # We only need to add the dependencies if ${PN} is not "kdelibs" or "kdepimlibs" 470_calculate_live_repo() {
295 if [[ ${PN} != "kdelibs" ]]; then 471 debug-print-function ${FUNCNAME} "$@"
472
473 SRC_URI=""
474 case ${KDE_SCM} in
475 svn)
476 # Determine branch URL based on live type
477 local branch_prefix
296 case "${EAPI}" in 478 case ${PV} in
297 2 | 2_pre3 | 2_pre2 | 2_pre1) 479 9999*)
298 DEPEND="${DEPEND} ${_operator}kde-base/kdelibs${_pv}[kdeprefix=]" 480 # trunk
299 RDEPEND="${RDEPEND} ${_operator}kde-base/kdelibs${_pv}[kdeprefix=]" 481 branch_prefix="trunk/KDE"
482 ;;
483 *)
484 # branch
485 branch_prefix="branches/KDE/$(get_kde_version)"
486 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
487 # @DESCRIPTION
488 # Suffix appended to ESVN_PROJECT depending on fetched branch.
489 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
490 ESVN_PROJECT_SUFFIX="-${PV}"
491 ;;
492 esac
493 # @ECLASS-VARIABLE: ESVN_MIRROR
494 # @DESCRIPTION:
495 # This variable allows easy overriding of default kde mirror service
496 # (anonsvn) with anything else you might want to use.
497 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
498 # Split ebuild, or extragear stuff
499 if [[ -n ${KMNAME} ]]; then
500 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
501 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
502 KMMODULE="${PN}"
503 fi
504 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
505 case ${KMNAME} in
506 kdebase-*)
507 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
508 ;;
509 kdelibs-*)
510 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
511 ;;
512 kdereview*)
513 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
514 ;;
515 kdesupport)
516 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
517 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
518 ;;
519 kde*)
520 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
521 ;;
522 extragear*|playground*)
523 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
524 # build packages from same svn location.
525 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
526 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
527 ;;
528 koffice)
529 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
530 ;;
531 *)
532 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
533 ;;
534 esac
535 else
536 # kdelibs, kdepimlibs
537 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
538 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
539 fi
540 # @ECLASS-VARIABLE: ESVN_UP_FREQ
541 # @DESCRIPTION:
542 # This variable is used for specifying the timeout between svn synces
543 # for kde-base and koffice modules. Does not affect misc apps.
544 # Default value is 1 hour.
545 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
546 ;;
547 git)
548 local _kmname
549 # @ECLASS-VARIABLE: EGIT_MIRROR
550 # @DESCRIPTION:
551 # This variable allows easy overriding of default kde mirror service
552 # (anongit) with anything else you might want to use.
553 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
554
555 # @ECLASS-VARIABLE: EGIT_REPONAME
556 # @DESCRIPTION:
557 # This variable allows overriding of default repository
558 # name. Specify only if this differ from PN and KMNAME.
559 if [[ -n ${EGIT_REPONAME} ]]; then
560 # the repository and kmname different
561 _kmname=${EGIT_REPONAME}
562 elif [[ -n ${KMNAME} ]]; then
563 _kmname=${KMNAME}
564 else
565 _kmname=${PN}
566 fi
567
568 # default branching
569 case ${PV} in
570 9999*) ;;
571 *)
572 # set EGIT_BRANCH and EGIT_COMMIT to $(get_kde_version)
573 case ${_kmname} in
574 kdeplasma-addons | kdepim | kdepim-runtime | kdepimlibs | okular)
575 EGIT_BRANCH="$(get_kde_version)"
576 ;;
577 marble)
578 EGIT_BRANCH="kde-$(get_kde_version)"
579 ;;
580 *) EGIT_BRANCH="KDE/$(get_kde_version)" ;;
581 esac
582 ;;
583 esac
584
585 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
586
587 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
588 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
589 ;;
590 esac
591}
592
593case ${BUILD_TYPE} in
594 live) _calculate_live_repo ;;
595 *) _calculate_src_uri ;;
596esac
597
598debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
599
600# @ECLASS-VARIABLE: PREFIX
601# @DESCRIPTION:
602# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
603# kde-base packages go into KDE4 installation directory (KDEDIR) by default.
604# No matter the PREFIX, package will be built against KDE installed in KDEDIR.
605
606# @FUNCTION: kde4-base_pkg_setup
607# @DESCRIPTION:
608# Do the basic KDEDIR settings and determine with which kde should
609# optional applications link
610kde4-base_pkg_setup() {
611 debug-print-function ${FUNCNAME} "$@"
612
613 if has kdeprefix ${IUSE//+} && use kdeprefix; then
614 eerror "Sorry, kdeprefix support has been removed."
615 eerror "Please remove kdeprefix from your USE variable."
616 die "kdeprefix support has been removed"
617 fi
618
619 if [[ ${CATEGORY}/${PN} != kde-base/kdelibs && ${CATEGORY}/${PN} != kde-base/kde-env ]] && \
620 { [[ ${KDE_REQUIRED} == always ]] || { [[ ${KDE_REQUIRED} == optional ]] && use kde; }; } && \
621 has_version kde-base/kdelibs[kdeprefix]; then
622 eerror "Sorry, kdeprefix support has been removed."
623 eerror "Please rebuild kdelibs without kdeprefix support."
624 die "kdeprefix support has been removed"
625 fi
626
627 # Don't set KDEHOME during compilation, it will cause access violations
628 unset KDEHOME
629
630 # Check if gcc compiler is fresh enough.
631 # In theory should be in pkg_pretend but we check it only for kdelibs there
632 # and for others we do just quick scan in pkg_setup because pkg_pretend
633 # executions consume quite some time.
634 [[ $(gcc-major-version) -lt 4 ]] || \
635 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
636 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
637
638 KDEDIR=/usr
639 : ${PREFIX:=/usr}
640 EKDEDIR=${EPREFIX}/usr
641
642 # Point pkg-config path to KDE *.pc files
643 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
644 # Point to correct QT plugins path
645 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/"
646
647 # Fix XDG collision with sandbox
648 export XDG_CONFIG_HOME="${T}"
649}
650
651# @FUNCTION: kde4-base_src_unpack
652# @DESCRIPTION:
653# This function unpacks the source tarballs for KDE4 applications.
654kde4-base_src_unpack() {
655 debug-print-function ${FUNCNAME} "$@"
656
657 if [[ ${BUILD_TYPE} = live ]]; then
658 case ${KDE_SCM} in
659 svn)
660 migrate_store_dir
661 subversion_src_unpack
300 ;; 662 ;;
301 *) 663 git)
302 DEPEND="${DEPEND} ${_operator}kde-base/kdelibs${_pv}" 664 git-2_src_unpack
303 RDEPEND="${RDEPEND} ${_operator}kde-base/kdelibs${_pv}"
304 ;; 665 ;;
305 esac 666 esac
306 if [[ ${PN} != "kdepimlibs" ]]; then
307 case "${EAPI}" in
308 2 | 2_pre3 | 2_pre2 | 2_pre1)
309 DEPEND="${DEPEND} ${_operator}kde-base/kdepimlibs${_pv}[kdeprefix=]"
310 RDEPEND="${RDEPEND} ${_operator}kde-base/kdepimlibs${_pv}[kdeprefix=]"
311 ;;
312 *)
313 DEPEND="${DEPEND} ${_operator}kde-base/kdepimlibs${_pv}"
314 RDEPEND="${RDEPEND} ${_operator}kde-base/kdepimlibs${_pv}"
315 esac
316 fi
317 fi
318
319 unset _operator _pv
320fi
321
322# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
323# koffice ebuild, the URI should be set in the ebuild itself
324if [[ -n ${KDEBASE} ]]; then
325 if [[ -n ${KMNAME} ]]; then
326 _kmname=${KMNAME}
327 else 667 else
328 _kmname=${PN} 668 unpack ${A}
329 fi
330 _kmname_pv="${_kmname}-${PV}"
331 if [[ ${NEED_KDE} != "svn" ]]; then
332 case ${KDEBASE} in
333 kde-base)
334 case ${PV} in
335 4.0.9* | 4.0.8*)
336 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
337 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2";;
338 esac
339 ;;
340 koffice)
341 SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2"
342 ;;
343 esac
344 fi
345 unset _kmname _kmname_pv
346fi
347
348debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
349
350# @ECLASS-VARIABLE: PREFIX
351# @DESCRIPTION:
352# Set the installation PREFIX. All kde-base ebuilds go into the KDE4 installation directory.
353# Applications installed by the other ebuilds go into /usr/ by default, this value
354# can be superseded by defining PREFIX before inheriting kde4-base.
355# This value is set on pkg_setup
356PREFIX=""
357
358debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SLOT ${SLOT} - NEED_KDE ${NEED_KDE}"
359
360# @FUNCTION: kde4-base_pkg_setup
361# @DESCRIPTION:
362# Adds flags needed by all of KDE 4 to $QT4_BUILT_WITH_USE_CHECK. Uses
363# kde4-functions_check_use from kde4-functions.eclass to print appropriate
364# errors and die if any required flags listed in $QT4_BUILT_WITH_USE_CHECK or
365# $KDE4_BUILT_WITH_USE_CHECK are missing.
366kde4-base_pkg_setup() {
367 debug-print-function $FUNCNAME "$@"
368
369 # Don't set KDEHOME during compile, it will cause access violations
370 unset KDEHOME
371
372 if [[ ${NEED_KDE} != none ]]; then
373
374 # Set PREFIX
375 case "${EAPI}" in
376 2 | 2_pre3 | 2_pre2 | 2_pre1)
377 if use kdeprefix; then
378 KDEDIR="/usr/kde/${_kdedir}"
379 KDEDIRS="/usr:/usr/local:${KDEDIR}"
380 else
381 KDEDIR="/usr"
382 KDEDIRS="/usr:/usr/local"
383 fi
384 ;;
385 *)
386 KDEDIR="/usr"
387 KDEDIRS="/usr:/usr/local"
388 ;;
389 esac
390 fi
391
392 # Set the prefix based on KDEDIR
393 # Make it a consequence of kdeprefix
394 PREFIX=${KDEDIR}
395
396 unset _kdedir
397
398 case "${EAPI}" in
399 2 | 2_pre3 | 2_pre2 | 2_pre1)
400 [[ -n ${QT4_BUILT_WITH_USE_CHECK} || -n ${KDE4_BUILT_WITH_USE_CHECK[@]} ]] && \
401 die "built_with_use illegal in this EAPI!"
402 ;;
403 *)
404 # Make KDE4_BUILT_WITH_USE_CHECK an array if it isn't already
405 local line kde4_built_with_use_check=()
406 if [[ -n ${KDE4_BUILT_WITH_USE_CHECK[@]} && $(declare -p KDE4_BUILT_WITH_USE_CHECK) != 'declare -a '* ]]; then
407 while read line; do
408 [[ -z ${line} ]] && continue
409 kde4_built_with_use_check+=("${line}")
410 done <<< "${KDE4_BUILT_WITH_USE_CHECK}"
411 KDE4_BUILT_WITH_USE_CHECK=("${kde4_built_with_use_check[@]}")
412 fi 669 fi
413
414 # KDE4 applications require qt4 compiled with USE="accessibility dbus gif jpeg png qt3support ssl zlib".
415 if has_version '<x11-libs/qt-4.4_alpha:4'; then
416 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} accessibility dbus gif jpeg png qt3support ssl zlib"
417 else
418 KDE4_BUILT_WITH_USE_CHECK=("${KDE4_BUILT_WITH_USE_CHECK[@]}"
419 "x11-libs/qt-core qt3support ssl"
420 "x11-libs/qt-gui accessibility dbus"
421 "x11-libs/qt-qt3support accessibility")
422 fi
423
424 if has opengl ${IUSE//+} && use opengl || [[ ${OPENGL_REQUIRED} == always ]]; then
425 if has_version '<x11-libs/qt-4.4.0_alpha:4'; then
426 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} opengl"
427 fi
428 fi
429 kde4-functions_check_use
430 ;;
431 esac
432} 670}
433 671
434# @FUNCTION: kde4-base_apply_patches
435# @DESCRIPTION:
436# This function applies patches.
437#
438# If the directory ${WORKDIR}/patches/ exists, we apply all patches in that
439# directory, provided they follow this format:
440# @CODE
441# - Monolithic ebuilds, (from kde-base)
442# - $CATEGORY=kde-base:
443# Apply ${CHILD_EBUILD_NAME}-${SLOT}-*{diff,patch}
444# - $CATEGORY=!kde-base:
445# Apply ${CHILD_EBUILD_NAME}-${PV}-*{diff,patch}
446# - Split ebuilds:
447# - $CATEGORY=kde-base:
448# Apply ${PN}-${SLOT}-*{diff,patch}
449# - $CATEGORY!=kde-base:
450# Apply ${PN}-${PV}-*{diff,patch}
451# @CODE
452#
453# If ${PATCHES} is non-zero all patches in it get applied. If there is more
454# than one patch please make ${PATCHES} an array for proper quoting.
455kde4-base_apply_patches() {
456 local _patchdir _packages _p _f
457 _patchdir="${WORKDIR}/patches/"
458 if [[ -d "${_patchdir}" ]]; then
459 if is-parent-package ${CATEGORY}/${PN} ; then
460 _packages="$(get-child-packages ${CATEGORY}/${PN})"
461 _packages="${_packages//${CATEGORY}\//} ${PN}"
462 else
463 _packages="${PN}"
464 fi
465 if [[ $(declare -p PATCHES) != 'declare -a '* ]]; then
466 die "PATCHES needs to be an array!"
467 fi
468 for _p in ${_packages}; do
469 for _f in "${_patchdir}"/${_p}-${PV}-*{diff,patch}; do
470 [[ -e ${_f} ]] && PATCHES+=("${_f}")
471 done
472 if [[ -n "${KDEBASE}" ]]; then
473 for _f in "${_patchdir}"/${_p}-${SLOT}-*{diff,patch}; do
474 [[ -e ${_f} ]] && PATCHES+=("${_f}")
475 done
476 fi
477 done
478 fi
479 [[ -n ${PATCHES[@]} ]] && base_src_unpack autopatch
480}
481
482# @FUNCTION: kde4-base_src_unpack 672# @FUNCTION: kde4-base_src_prepare
483# @DESCRIPTION: 673# @DESCRIPTION:
484# This function unpacks the source tarballs for KDE4 applications. 674# General pre-configure and pre-compile function for KDE4 applications.
485#
486# If no argument is passed to this function, then standard src_unpack is
487# executed. Otherwise options are passed to base_src_unpack.
488#
489# In addition it calls kde4-base_apply_patches when no arguments are passed to
490# this function.
491#
492# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and 675# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
676# enable_selected_linguas() and enable_selected_doc_linguas()
493# enable_selected_linguas() in kde4-functions.eclass(5) for further details. 677# in kde4-functions.eclass(5) for further details.
494kde4-base_src_unpack() { 678kde4-base_src_prepare() {
495 debug-print-function $FUNCNAME "$@" 679 debug-print-function ${FUNCNAME} "$@"
496 680
497 [[ -z "${KDE_S}" ]] && KDE_S="${S}" 681 # enable handbook and linguas only when not using live ebuild
498
499 if [[ -z $* ]]; then
500 # Unpack first and deal with KDE patches after examing possible patch sets.
501 # To be picked up, patches need to conform to the guidelines stated before.
502 # Monolithic ebuilds will use the split ebuild patches.
503 [[ -d "${KDE_S}" ]] || unpack ${A}
504 base_src_unpack $*
505 else
506 # Call base_src_unpack, which unpacks and patches
507 # step by step transparently as defined in the ebuild.
508 base_src_unpack $*
509 fi
510
511 # Updated cmake dir
512 if [[ -d "${WORKDIR}/cmake" ]] && [[ -d "${KDE_S}/cmake" ]]; then
513 ebegin "Updating cmake/ directory..."
514 rm -rf "${KDE_S}/cmake" || die "Unable to remove old cmake/ directory"
515 ln -s "${WORKDIR}/cmake" "${KDE_S}/cmake" || die "Unable to symlink the new cmake/ directory"
516 eend 0
517 fi
518 682
519 # Only enable selected languages, used for KDE extragear apps. 683 # Only enable selected languages, used for KDE extragear apps.
520 if [[ -n ${KDE_LINGUAS} ]]; then 684 if [[ -n ${KDE_LINGUAS} ]]; then
521 enable_selected_linguas 685 enable_selected_linguas
522 fi 686 fi
687
688 # Enable/disable handbooks for kde4-base packages
689 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
690 # kdelibs inherits kde4-base but handle installing the handbook itself
691 if ! has kde4-meta ${INHERITED} && has handbook ${IUSE//+}; then
692 if [[ ${KDEBASE} == kde-base ]]; then
693 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
694 # documentation in kde4-functions
695 : ${KDE_DOC_DIRS:=doc}
696 local dir
697 for dir in ${KDE_DOC_DIRS}; do
698 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
699 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
700 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
701 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
702 -i CMakeLists.txt || die "failed to comment out handbook"
703 done
704 fi
705 else
706 enable_selected_doc_linguas
707 fi
708 fi
709
710 # SCM bootstrap
711 if [[ ${BUILD_TYPE} = live ]]; then
712 case ${KDE_SCM} in
713 svn) subversion_src_prepare ;;
714 esac
715 fi
716
717 # Apply patches
718 base_src_prepare
719
720 # Save library dependencies
721 if [[ -n ${KMSAVELIBS} ]] ; then
722 save_library_dependencies
723 fi
724
725 # Inject library dependencies
726 if [[ -n ${KMLOADLIBS} ]] ; then
727 load_library_dependencies
728 fi
729
730 # Replace KDE4Workspace library targets
731 find "${S}" -name CMakeLists.txt \
732 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' {} + \
733 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' {} + \
734 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' {} + \
735 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' {} + \
736 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' {} + \
737 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' {} + \
738 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' {} + \
739 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' {} + \
740 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' {} + \
741 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' {} + \
742 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' {} + \
743 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' {} + \
744 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' {} + \
745 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' {} + \
746 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' {} + \
747 || die 'failed to replace KDE4Workspace library targets'
748
749 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
750 if [[ -z ${KDEBASE} ]]; then
751 find "${S}" -name "*.docbook" \
752 -exec sed -i -r \
753 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
754 || die 'failed to fix DocBook variant version'
755 fi
756}
757
758# @FUNCTION: kde4-base_src_configure
759# @DESCRIPTION:
760# Function for configuring the build of KDE4 applications.
761kde4-base_src_configure() {
762 debug-print-function ${FUNCNAME} "$@"
763
764 # Build tests in src_test only, where we override this value
765 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
766
767 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
768 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
769 fi
770
771 if has debug ${IUSE//+} && use debug; then
772 # Set "real" debug mode
773 CMAKE_BUILD_TYPE="Debugfull"
774 else
775 # Handle common release builds
776 append-cppflags -DQT_NO_DEBUG
777 fi
778
779 # Set distribution name
780 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
781
782 # Here we set the install prefix
783 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
784
785 # Use colors
786 QTEST_COLORED=1
787
788 # Shadow existing /usr installations
789 unset KDEDIRS
790
791 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
792 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
793 #kde-config -path data unavailable when cross-compiling
794 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
795
796 # sysconf needs to be /etc, not /usr/etc
797 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
798
799 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
800 mycmakeargs=(${mycmakeargs})
801 fi
802
803 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
804
805 cmake-utils_src_configure
523} 806}
524 807
525# @FUNCTION: kde4-base_src_compile 808# @FUNCTION: kde4-base_src_compile
526# @DESCRIPTION: 809# @DESCRIPTION:
527# General function for compiling KDE4 applications. 810# General function for compiling KDE4 applications.
528kde4-base_src_compile() { 811kde4-base_src_compile() {
529 debug-print-function ${FUNCNAME} "$@" 812 debug-print-function ${FUNCNAME} "$@"
530 case "${EAPI}" in
531 2)
532 ;;
533 *)
534 kde4-base_src_configure
535 ;;
536 esac
537 if [[ -d ${WORKDIR}/${PN}_build ]]; then
538 pushd "${WORKDIR}"/${PN}_build > /dev/null
539 fi
540 [ -e [Mm]akefile ] && kde4-base_src_make
541}
542 813
543# @FUNCTION: kde4-base_src_configure
544# @DESCRIPTION:
545# Function for configuring the build of KDE4 applications.
546kde4-base_src_configure() {
547 debug-print-function ${FUNCNAME} "$@"
548
549 # Final flag handling
550 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
551 echo "Activating enable-final flag"
552 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_FINAL=ON"
553 fi
554
555 # Enable generation of HTML handbook
556 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then
557 echo "Enabling building of HTML handbook"
558 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_HTMLHANDBOOK=ON"
559 fi
560
561 # Build tests in src_test only, where we override this value
562 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=OFF"
563
564 # Set distribution name
565 [[ ${PN} == "kdelibs" ]] && mycmakeargs="${mycmakeargs} -DKDE_DISTRIBUTION_TEXT=Gentoo"
566
567 # runpath linking
568 mycmakeargs="${mycmakeargs} -DKDE4_USE_ALWAYS_FULL_RPATH=ON"
569
570 # Here we set the install prefix
571 mycmakeargs="${mycmakeargs} -DCMAKE_INSTALL_PREFIX=${PREFIX}"
572
573 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc
574 [[ "${PREFIX}" == "/usr" ]] && mycmakeargs="${mycmakeargs} -DSYSCONF_INSTALL_DIR=/etc"
575
576 # Set environment
577 QTEST_COLORED=1
578 QT_PLUGIN_PATH=${KDEDIR}/$(get_libdir)/kde4/plugins/
579
580 # hardcode path to *.cmake KDE files
581 PKG_CONFIG_PATH="${PKG_CONFIG_PATH:+${PKG_CONFIG_PATH}:}${KDEDIR}/$(get_libdir)/pkgconfig"
582
583 [ -e CMakeLists.txt ] && cmake-utils_src_configureout
584}
585
586# @FUNCTION: kde4-base_src_make
587# @DESCRIPTION:
588# Function for building KDE4 applications.
589# Options are passed to cmake-utils_src_make.
590kde4-base_src_make() {
591 debug-print-function ${FUNCNAME} "$@"
592
593 cmake-utils_src_make "$@" 814 cmake-utils_src_compile "$@"
594} 815}
595 816
596# @FUNCTION: kde4-base_src_test 817# @FUNCTION: kde4-base_src_test
597# @DESCRIPTION: 818# @DESCRIPTION:
598# Function for testing KDE4 applications. 819# Function for testing KDE4 applications.
599kde4-base_src_test() { 820kde4-base_src_test() {
600 debug-print-function ${FUNCNAME} "$@" 821 debug-print-function ${FUNCNAME} "$@"
601 822
602 # Override this value, set in kde4-base_src_configure() 823 # Override this value, set in kde4-base_src_configure()
603 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=ON" 824 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
604 cmake-utils_src_compile 825 cmake-utils_src_configure
826 kde4-base_src_compile
605 827
828 # When run as normal user during ebuild development with the ebuild command, the
829 # kde tests tend to access the session DBUS. This however is not possible in a real
830 # emerge or on the tinderbox.
831 # > make sure it does not happen, so bad tests can be recognized and disabled
832 unset DBUS_SESSION_BUS_ADDRESS
833
834 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
835 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
836 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
837 # surprise- we are already INSIDE virtualmake!!!
838 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
839 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
840 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
841 debug-print " kde4-base.eclass docs for details... Applying workaround."
842 cmake-utils_src_test
843 else
844 VIRTUALX_COMMAND="cmake-utils_src_test" virtualmake
845 fi
846 else
606 cmake-utils_src_test 847 cmake-utils_src_test
848 fi
607} 849}
608 850
609# @FUNCTION: kde4-base_src_install 851# @FUNCTION: kde4-base_src_install
610# @DESCRIPTION: 852# @DESCRIPTION:
611# Function for installing KDE4 applications. 853# Function for installing KDE4 applications.
612kde4-base_src_install() { 854kde4-base_src_install() {
613 debug-print-function ${FUNCNAME} "$@" 855 debug-print-function ${FUNCNAME} "$@"
614 856
615 kde4-base_src_make_doc 857 if [[ -n ${KMSAVELIBS} ]] ; then
616 if [[ -d ${WORKDIR}/${PN}_build ]]; then 858 install_library_dependencies
617 pushd "${WORKDIR}"/${PN}_build > /dev/null
618 fi 859 fi
619 [ -e [Mm]akefile ] && cmake-utils_src_install
620}
621 860
622# @FUNCTION: kde4-base_src_make_doc
623# @DESCRIPTION:
624# Function for installing the documentation of KDE4 applications. 861 # Install common documentation of KDE4 applications
625kde4-base_src_make_doc() {
626 debug-print-function ${FUNCNAME} "$@"
627
628 local doc 862 local doc
629 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 863 if ! has kde4-meta ${INHERITED}; then
630 [[ -s $doc ]] && dodoc ${doc} 864 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
631 done 865 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
632
633 if [[ -z ${KMNAME} ]]; then
634 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do
635 if [[ -s $doc ]]; then
636 local doc_complete=${doc}
637 doc="${doc#*/}"
638 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
639 fi
640 done 866 done
867 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
868 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
869 done
641 fi 870 fi
642 871
643 if [[ -n ${KDEBASE} && -d "${D}"/usr/share/doc/${PF} ]]; then 872 cmake-utils_src_install
644 # work around bug #97196 873
645 dodir /usr/share/doc/kde && \ 874 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
646 mv "${D}"/usr/share/doc/${PF} "${D}"/usr/share/doc/kde/ || \ 875 # because then khelpcenter can't find the docs
647 die "Failed to move docs to kde/ failed." 876 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
648 fi 877 docompress -x ${PREFIX}/share/doc/HTML
878}
879
880# @FUNCTION: kde4-base_pkg_preinst
881# @DESCRIPTION:
882# Function storing icon caches
883kde4-base_pkg_preinst() {
884 debug-print-function ${FUNCNAME} "$@"
885
886 gnome2_icon_savelist
649} 887}
650 888
651# @FUNCTION: kde4-base_pkg_postinst 889# @FUNCTION: kde4-base_pkg_postinst
652# @DESCRIPTION: 890# @DESCRIPTION:
653# Function to rebuild the KDE System Configuration Cache after an application has been installed. 891# Function to rebuild the KDE System Configuration Cache after an application has been installed.
654kde4-base_pkg_postinst() { 892kde4-base_pkg_postinst() {
893 debug-print-function ${FUNCNAME} "$@"
894
895 gnome2_icon_cache_update
896 fdo-mime_desktop_database_update
897 fdo-mime_mime_database_update
655 buildsycoca 898 buildsycoca
899
900 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
901 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
902 echo
903 ewarn "WARNING! you have kdeenable final useflag enabled."
904 ewarn "This useflag needs to be enabled on ALL kde using packages and"
905 ewarn "is known to cause issues."
906 ewarn "You are using this setup at your own risk and the kde team does not"
907 ewarn "take responsibilities for dead kittens."
908 echo
909 fi
910 if [[ ${BUILD_TYPE} = live ]]; then
911 echo
912 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
913 einfo "Use it at your own risk."
914 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
915 echo
916 fi
917 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
918 if [[ ${KDEBASE} != kde-base ]] && \
919 ! has_version 'kde-base/kdebase-runtime-meta' && \
920 ! has_version 'kde-base/kdebase-startkde'; then
921 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
922 echo
923 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
924 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
925 ewarn "With this setting you are unsupported by KDE team."
926 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
927 fi
928 fi
929 fi
656} 930}
657 931
658# @FUNCTION: kde4-base_pkg_postrm 932# @FUNCTION: kde4-base_pkg_postrm
659# @DESCRIPTION: 933# @DESCRIPTION:
660# Function to rebuild the KDE System Configuration Cache after an application has been removed. 934# Function to rebuild the KDE System Configuration Cache after an application has been removed.
661kde4-base_pkg_postrm() { 935kde4-base_pkg_postrm() {
936 debug-print-function ${FUNCNAME} "$@"
937
938 gnome2_icon_cache_update
939 fdo-mime_desktop_database_update
940 fdo-mime_mime_database_update
662 buildsycoca 941 buildsycoca
663} 942}

Legend:
Removed from v.1.18  
changed lines
  Added in v.1.97

  ViewVC Help
Powered by ViewVC 1.1.20